//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#ifndef ULM_WEATHERBALLOON_ULM_ENS161_H
#define ULM_WEATHERBALLOON_ULM_ENS161_H


#include "ScioSense_ENS160.h"
#include "Ulm_GenericSensor.h"

struct Ulm_ENS161_Sample {
    uint16_t co2, tvoc;             // CO2 in ppm, TVOC in ppb.
    uint8_t aqi;                    // Air quality index from 0 to 5.
    uint16_t aqi500;                // Air quality index from 0 to 500.
};

class Ulm_ENS161 : ScioSense_ENS160, public Ulm_GenericSensor<struct Ulm_ENS161_Sample> {

public:
    /**
     * Constructor.
     * @param address the i2c address of the ENS16X sensor.
     * @param wire the i2c interface.
     */
    explicit Ulm_ENS161(uint8_t address = ENS160_I2CADDR_0, TwoWire &wire = Wire);

    /**
     * Inits the sensor.
     * @return {@code true} on success, {@code false} otherwise.
     */
    bool begin() override;

    bool sample(Ulm_ENS161_Sample &t) override;
};

typedef Ulm_ENS161 Ulm_ENS160;

#endif //ULM_WEATHERBALLOON_ULM_ENS161_H
